#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <conio.h>
#include "meta_patcher.h"

#define EXIT 0
#define SECOND_MENU_MAX_OPTION 2

void printHeader()
{
    printf("******************************************************\n");
    printf("*                                                    *\n");
    printf("*                 Cloak Remover  v1.5               *\n");
    printf("*                                                    *\n");
    printf("******************************************************\n");
}

// Functions Prototypes
int menu0();
int menu1(); // Displays the first menu (select region menu) and returns the option selected
int menu2(); // Displays the second menu and returns the option selected
int backupExists();
void moveFiles(char* srcFolder, char* destFolder);
void copyFiles(char* srcFolder, char* destFolder);
void createBackup();
void displayResults();
char* getFolderName(char* fileName);
void initProgram();
void cleanUp();

void initProgram()
{
    bdoRootFolder = oneLevelDown(getCurrentPath());

    if (!backupExists())
    {
        createBackup();
    }

    filesToPatchCount = 13;
    fileBlocks = (FileBlock*) calloc (filesToPatchCount , sizeof(FileBlock));

     fileBlocks[0].hash = -1505596150;
     strcpy(fileBlocks[0].folderName,"character\\texture\\");
    strcpy(fileBlocks[0].fileName,"phw_00_cloak_0043_hair.dds");

    fileBlocks[1].hash = 198557763;
    strcpy(fileBlocks[1].folderName,"character\\texture\\");
    strcpy(fileBlocks[1].fileName,"phw_00_eca_0030.dds");

    fileBlocks[2].hash = 1291929737;
    strcpy(fileBlocks[2].folderName,"character\\texture\\");
    strcpy(fileBlocks[2].fileName,"phw_00_ub_0043.dds");

    fileBlocks[3].hash = -2042695355;
    strcpy(fileBlocks[3].folderName,"character\\texture\\");
    strcpy(fileBlocks[3].fileName,"phw_00_ub_0043_hair.dds");

    fileBlocks[4].hash = 870323250;
    strcpy(fileBlocks[4].folderName,"character\\texture\\");
    strcpy(fileBlocks[4].fileName,"phw_00_ub_0011.dds");

    fileBlocks[5].hash = -1855899207;
    strcpy(fileBlocks[5].folderName,"character\\");
    strcpy(fileBlocks[5].fileName,"partcutdesc.xml");

    fileBlocks[6].hash = -11305379;
    strcpy(fileBlocks[6].folderName,"character\\model\\1_pc\\2_phw\\armor\\9_upperbody\\");
    strcpy(fileBlocks[6].fileName,"phw_00_ub_0030.pac");

    fileBlocks[7].hash = -1915213128;
    strcpy(fileBlocks[7].folderName,"character\\texture\\");
    strcpy(fileBlocks[7].fileName,"phw_00_ub_0004.dds");

     fileBlocks[8].hash = -118093269;
     strcpy(fileBlocks[8].folderName,"character\\model\\1_pc\\2_phw\\armor\\10_lowerbody\\");
     strcpy(fileBlocks[8].fileName,"phw_00_lb_0004.pac");

     fileBlocks[9].hash = -1886292228;
    strcpy(fileBlocks[9].folderName,"character\\texture\\");
    strcpy(fileBlocks[9].fileName,"phw_01_lb_0003.dds");

     fileBlocks[10].hash = -918697594;
     strcpy(fileBlocks[10].folderName,"character\\texture\\");
     strcpy(fileBlocks[10].fileName,"phw_00_lb_0004.dds");

      fileBlocks[11].hash = 325025669;
     strcpy(fileBlocks[11].folderName,"character\\texture\\");
     strcpy(fileBlocks[11].fileName,"phw_00_lb_0004_dec.dds");

    fileBlocks[12].hash = -1031992892;
     strcpy(fileBlocks[12].folderName,"character\\texture\\");
     strcpy(fileBlocks[12].fileName,"phw_01_sho_0002_dec.dds");


     if (fileExists("patcher_resources\\clead_selected_option.bin"))
     {
         FILE *fp = openFile("patcher_resources\\clead_selected_option.bin","rb");
         fread(&cleadShortsOption,sizeof(int),1,fp);
         fclose(fp);

         if (cleadShortsOption < 1  || cleadShortsOption > 4)
         {
             cleadShortsOption = 1;
         }
     }




    /*printf("\nCounting files...\n\n");
    // Counts how many files there is in the "files_to_patch" folder assigns to filesToPatchCount,
    // and get all the file names in folders and sub folders and returns them as an array of strings
    char** fileNames = getAllFiles(FILES_TO_PATCH_FOLDER_NAME,"*",&filesToPatchCount);

    if (filesToPatchCount == 0)
    {
        printf("No files present in %s\n\n",FILES_TO_PATCH_FOLDER_NAME);
        system("PAUSE");
        exit(1);
    }

    printf("%ld files were found in %s\n\n", filesToPatchCount, FILES_TO_PATCH_FOLDER_NAME);

    filesToPatch = (FileToPatch*)malloc(filesToPatchCount * sizeof(FileToPatch));

    long i = 0;
    for (i = 0; i < filesToPatchCount; i++)
    {
        filesToPatch[i].fileName = fileNames[i];
        filesToPatch[i].patched = 0;
    }*/
}

char** getBackupList(long* backupCount)
{
    return getAllFiles(getCurrentPath(),"backup",backupCount);
}

int selectBackup(char** backupNames, long backupCount)
{
    long i = 0;
     char input[32];
     int optionSelected = -1;
    int backupSelected = -1;

    printf("\n\nList of backups:\n");
    for (i = 0; i < backupCount; i++)
    {
       printf("%ld - %s\n", i + 1, backupNames[i]);
    }
    while (optionSelected < 1 || optionSelected > backupCount)
    {
        printf("\nSelect backup number: ");
        fgets(input,32,stdin);

        optionSelected = atoi(input);
        backupSelected = optionSelected - 1;

        if (optionSelected < 1 || optionSelected > backupCount)
        {
            printf("\nInvalid option!\n\n");
        }
    }

    return backupSelected;
}

int main()
{
    initProgram();

    int menu0ChosenOption = menu0();





    while (menu0ChosenOption != EXIT)
    {
        if (menu0ChosenOption == 3)
        {
            long backupCount = 0;
            char** backupNames = getBackupList(&backupCount);
            if (backupCount != 0)
            {
                int backupSelected = selectBackup(backupNames, backupCount);
                char command[MAX_PATH];
                sprintf(command,"xcopy /y \"%s\" pad00000.meta",backupNames[backupSelected]);
                system(command);
            }
            else
            {
                 printf("No backup was found");
            }
            printf("\n");
            system("PAUSE");
        }
        else if (menu0ChosenOption == 2)
        {
           menu1();
        }
        else if (menu0ChosenOption != EXIT)
        {
            runMetaPatcher();
            displayResults();

            printf("\nCopying Files...\n");

            int i = 0;
            for (i = 0; i < filesToPatchCount; i++)
            {
                char* srcFolder = concatenate(FILES_TO_PATCH_FOLDER_NAME,fileBlocks[i].folderName);
                char* destFolder = concatenate(bdoRootFolder,fileBlocks[i].folderName);

                if (strcmpi(fileBlocks[i].fileName,"phw_00_lb_0004.pac") == 0)
                {
                    srcFolder = (char*) realloc(srcFolder,MAX_PATH);
                    if (cleadShortsOption == 1 || cleadShortsOption == 4)
                    {
                        strcpy(srcFolder, "patcher_resources\\models\\clead_lowerbody\\bern\\");
                    }
                    else if (cleadShortsOption == 3)
                    {
                        strcpy(srcFolder, "patcher_resources\\models\\clead_lowerbody\\none\\");
                    }
                    else
                    {
                        strcpy(srcFolder, "patcher_resources\\models\\clead_lowerbody\\default\\");
                    }
                }
                else if (strcmpi(fileBlocks[i].fileName,"phw_02_lb_0006.pac") == 0)
                {
                    srcFolder = (char*) realloc(srcFolder,MAX_PATH);

                    strcpy(srcFolder, "patcher_resources\\models\\bern_armor\\");
                }

                else if (strcmpi(fileBlocks[i].fileName,"phw_01_lb_0003.dds") == 0)
                {
                    srcFolder = (char*) realloc(srcFolder,MAX_PATH);
                    if (cleadShortsOption == 1)
                    {
                        strcpy(srcFolder, "patcher_resources\\textures\\bern_shorts\\red\\");
                    }
                    else if (cleadShortsOption == 4)
                    {
                        strcpy(srcFolder, "patcher_resources\\textures\\bern_shorts\\belt_only\\");
                    }
                    else
                    {
                       strcpy(srcFolder, "patcher_resources\\textures\\bern_shorts\\default\\");
                    }
                }


                else if (strcmpi(fileBlocks[i].fileName,"partcutdesc.xml") == 0)
                {
                    srcFolder = (char*) realloc(srcFolder,MAX_PATH);
                    if (cleadShortsOption == 4)
                    {
                        strcpy(srcFolder, "patcher_resources\\xml\\clead_uncut\\");
                    }
                    else
                    {
                       strcpy(srcFolder, "patcher_resources\\xml\\default\\");
                    }
                }

                systemCopy(fileBlocks[i].fileName,srcFolder,destFolder);
            }
            printf("\nDone.\n");


            if (menu0ChosenOption != EXIT)
            {
                printf("\n");
                system("PAUSE");
            }
        }
        menu0ChosenOption = menu0();
    }



    return 0;
}
int menu0()
{
    char input[32];       // A simple buffer to store whatever the user types in the menu
    int optionSelected = -1;

     // Display the menu to select the region
    while(optionSelected != EXIT) // This condition makes the menu repeat itself until a valid input is entered
    {
        system("cls"); // clears the screen
        printHeader();
        printf("What do you want to do?\n");
        printf("1 - Apply Patch\n");
        printf("2 - Clead Outfit Options\n");
        printf("3 - Restore backup\n");
        printf("0 - Exit\n");
        printf("\nEnter your choice: ");
        fgets(input,32,stdin); // Gets the input from the keyboard

        // Converts the read string to int
        optionSelected = atoi(input);
        // This variable also tells the program later which one of the "moddedBytes" the program should use when replacing the bytes

        if (optionSelected == EXIT)
        {
            break;
        }

         // If the user entered an invalid option, displays a error message
        if(optionSelected < 1 || optionSelected > 3)
        {
            printf("\nInvalid option!\n\n");
            system("PAUSE");
        }
        else
        {
            break;
        }
    }

    return optionSelected;
}

int menu1()
{
    char input = '\0';
    int inputInt = 1;

    while(1)
    {
        system("cls");
        printf("\n\nClead Outfit Lowerbody Options:\n");
        printf("\n1 - Bern Shorts"); if (cleadShortsOption == -1 || cleadShortsOption == 1) { printf(" <--");}
        printf("\n2 - Default pants"); if (cleadShortsOption == 2) { printf(" <--");}
        printf("\n3 - None");  if (cleadShortsOption == 3) { printf(" <--");}
        printf("\n4 - Bern belt only"); if (cleadShortsOption == 4) { printf(" <--");}
        printf("\n\nENTER - Confirm");
        input = getch();

        inputInt = input - 48;


        if (input == 13)
        {
            FILE* fp = fopen("patcher_resources\\clead_selected_option.bin","wb");
            fwrite(&cleadShortsOption,sizeof(int),1,fp);
            fclose(fp);
            break;
        }

        if(input < '1' || input > '4')
        {
            printf("\nInvalid option!\n\n");
            system("PAUSE");
        }
        else
        {
            cleadShortsOption = inputInt;
        }
    }

    return inputInt;
}

int menu2()
{
    char input[32];       // A simple buffer to store whatever the user types in the menu
    int optionSelected = -1;

    while(optionSelected < 0 || optionSelected > SECOND_MENU_MAX_OPTION) // This condition makes the menu repeat itself until a valid input is entered
    {
        system("PAUSE");
        system("cls");
        printf("\nWhat do you want to do with the files in the \"files_to_patch\" folder?\n\n(Warning: Overwrites will occur without prompting)\n");
        printf("1 - Copy them to their right place\n");
        printf("2 - Move them to their right place\n");
        printf("0 - Exit\n") ;
        printf("\nEnter your choice: ");
        fgets(input,32,stdin); // Gets the input from the keyboard

        // Converts the read string to int
        optionSelected = atoi(input);

        // If the user entered an invalid option, displays a error message
        if(optionSelected < 0 || optionSelected > SECOND_MENU_MAX_OPTION)
        {
            printf("\nInvalid option!\n\n");
        }
    }
    return (optionSelected);
}

void copyFiles(char* srcFolder, char* destFolder)
{
    char* tmpPath = concatenate(bdoRootFolder,"tmp\\");
    moveFiles(srcFolder,tmpPath);
    systemCopy("*",tmpPath,destFolder);
    moveFiles(tmpPath,srcFolder);
    char rdCommand[256];
    sprintf(rdCommand, "rd /s /q \"%s\"", tmpPath);
    system(rdCommand);
}

void moveFiles(char* srcFolder, char* destFolder)
{
     // Opens the current dir
    DIR* pDir = opendir (srcFolder);
    struct dirent *pDirent;

    if (pDir == NULL)
    {
        printf ("Cannot open directory: '%s'\n", srcFolder);
        exit(1);
    }

    // Writes all the file names in this dir, into the file
    while ((pDirent = readdir(pDir)) != NULL)
    {
        char* fileName = pDirent->d_name;

         //Makes sure it doesn't write stuff like "." or ".." into the file
        if((strcmpi(fileName,".") != 0) && (strcmpi(fileName,"..") != 0))
        {
            //Creates the complete path (E.g. from C:\folder goes to c:\folder\something)
            char* completePath = buildFullPath(srcFolder,fileName);

            // If it's a file, not a folder
            if (!isDirectory(completePath))
            {
                char* folderName = getFolderName(fileName);
                char* folderPath = concatenate(destFolder,folderName);
                char* destPath = concatenate(folderPath,fileName);
                 strreplace(folderPath,'/','\\');

                DIR* dir = opendir(folderPath);

                if (dir)
                {
                    closedir(dir);
                }
                else
                {
                    char mdCommand[256];
                    sprintf(mdCommand,"md \"%s\"",folderPath);
                    system(mdCommand);
                }

                //printf("\nrename %s %s\n", completePath, concatenate(folderPath,fileName));

                if (fileExists(destPath))
                {
                    remove(destPath);
                }

                rename(completePath,destPath);
            }
            else
            {
                strcat(completePath,"\\");
                moveFiles(completePath, destFolder);
            }
        }
    }

    //Closes the dir and the file
    closedir (pDir);
}

char* getFolderName(char* fileName)
{
    long i = 0;
    for (i = 0; i < fileBlocksCount; i++)
    {
        if (strcmpi(fileName,fileBlocks[i].fileName) == 0)
        {
            return fileBlocks[i].folderName;
        }
    }
    char* blank = "";
    return blank;
}


void cleanUp()
{
    long i = 0;
    for (i = 0; i < fileBlocksCount; i++)
    {
        free(fileBlocks[i].fileName);
        free(fileBlocks[i].folderName);
    }
    free(fileBlocks);

    for (i = 0; i < filesToPatchCount; i++)
    {
        free(filesToPatch[i].fileName);
    }
    free(filesToPatch);
}


void displayResults()
{
    printColor("\n\n-------------- Overall Results --------------\n", YELLOW);
    printf("Files Patched: \033[32;1m%d\033[0m Files Not Patched: \033[31;1m%d\033[0m",overrallSuccessCount, (int)(filesToPatchCount - overrallSuccessCount));

    if (overrallFailsCount > 0)
    {
        printColor("\n\n------- Those files couldn't patched --------\n",RED);
        long i = 0;
        for (i = 0; i < filesToPatchCount; i++)
        {
            if (filesToPatch[i].patched == 0)
            {
                printf("%s\n", filesToPatch[i].fileName);
            }
        }
        printf("\nThis is not an error.\nUnfortunately, there is no way to make them work.");
    }

    if (overrallSuccessCount == filesToPatchCount)
    {
        printColor("\n\n\tAll files have been patched successfully!", GREEN);
    }

    printf("\n\n");
}


void createBackup()
{
    int backupNameLen = strlen("pad00000[YYYY-MM-DD].meta.backup");
    char* backupName = (char*)malloc(backupNameLen + 1);

    time_t now;
    time(&now);

    struct tm* now_tm;
    now_tm = localtime(&now);

    strftime (backupName, backupNameLen + 1, "pad00000[%Y-%m-%d].meta.backup", now_tm);

    char* cmd = (char*) malloc(strlen("copy pad00000.meta pad00000[YYYY-MM-DD].meta.backup") + 1);
    sprintf(cmd,"copy pad00000.meta %s", backupName);
    system(cmd);

    printf("\nA new backup was created: %s\n",backupName);
}

int backupExists()
{
    char* currentPath = getCurrentPath();
    int backupCount = countFilesSingleFolder(currentPath,"backup");
    if (backupCount == 1)
    {
        printf("%d backup was found\n", backupCount);
    }
    else
    {
        printf("%d backups were found\n", backupCount);
    }
    char** backups = getFilesSingleFolder(currentPath,"backup", backupCount);
    FILE* backupFile = NULL;
    FILE* metaFile = openFile("pad00000.meta","rb");

    int i = 0;
    for(i = 0; i < backupCount; i++)
    {
        backupFile = fopen(backups[i],"rb");
        if (getFileSize(backupFile) == getFileSize(metaFile))
        {
            fclose(metaFile);
            fclose(backupFile);
            return 1;
        }
        fclose(backupFile);
    }
    fclose(metaFile);
    return 0;
}

