#include "../include/meta_patcher.h"

void runMetaPatcher()
{
    FILE* metaFile = openFile("pad00000.meta","rb");
    printf("\n\nReading meta file...");
    MemFileInt* metaFileInMemory = copyFileToMemoryAsInt(metaFile);
    fclose(metaFile);
    printf("\nDone...");

    overrallSuccessCount = 0;
    overrallFailsCount = 0;

    int i = 0;
    printf("\n\n---------------------All Set----------------------\n");

    printColor("\n\n================== Applying Patch ==================", YELLOW);
    for (i = 0; i < filesToPatchCount; i++)
    {
        printf("\n(%d/%ld): %s ", i + 1, filesToPatchCount, fileBlocks[i].fileName);

        long hashLocation = locateIntInMemory(fileBlocks[i].hash,metaFileInMemory);

        if (hashLocation != NOT_FOUND)
        {
            metaFileInMemory->block[hashLocation + 1] = MODDED_BYTES[KR][0];
            metaFileInMemory->block[hashLocation + 2] = MODDED_BYTES[KR][1];

            printColor("Success!", GREEN);
            overrallSuccessCount++;
        }
        else
        {
            printColor("Not Found", RED);
            printf(" Hash: %ld", fileBlocks[i].hash);
            overrallFailsCount++;
        }
    }

    printf("\n\nWriting changes to meta file...");
    metaFile = openFile("pad00000.meta","rb+");
    for (i = 0; i < metaFileInMemory->size; i++)
    {
        fwrite(&metaFileInMemory->block[i],sizeof(int),1,metaFile);
    }
    fclose(metaFile);

    free(metaFileInMemory->block);
    free(metaFileInMemory);
    printf("\nDone...");
}



